diff -uwr sourceold/scripts/jfwcust.cpp source/scripts/jfwcust.cpp
--- sourceold/scripts/jfwcust.cpp	2011-10-11 23:05:21.089843700 +0800
+++ source/scripts/jfwcust.cpp	2011-12-01 12:26:58.960937500 +0800
@@ -485,7 +485,7 @@
 			{
 				firstframe = Get_Animation_Frame(obj);
 			}
-			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,subobject,firstframe,-1,Get_Int_Parameter("Blended"));
 		}
 	}
 	if (type == Get_Int_Parameter("Disable"))
diff -uwr sourceold/scripts/jfwpow.cpp source/scripts/jfwpow.cpp
--- sourceold/scripts/jfwpow.cpp	2011-10-11 23:05:01.913085900 +0800
+++ source/scripts/jfwpow.cpp	2011-12-01 12:52:17.931640600 +0800
@@ -111,6 +111,21 @@
 	}
 }
 
+void JFW_Change_Character_Powerup_2::Custom(GameObject *obj,int type,int param,GameObject *sender)
+{
+	if (type == CUSTOM_EVENT_POWERUP_GRANTED)
+	{
+		if (Commands->Get_Player_Type(sender) == 0)
+		{
+			Change_Character(sender,Get_Parameter("Nod_Preset"));
+		}
+		else if (Commands->Get_Player_Type(sender) == 1)
+		{
+			Change_Character(sender,Get_Parameter("GDI_Preset"));
+		}
+	}
+}
+
 void JFW_Clear_Money_Create::Created(GameObject *obj)
 {
 	Commands->Give_Money(obj,-Commands->Get_Money(obj),false);
@@ -141,4 +156,5 @@
 ScriptRegistrant<JFW_Powerup_Send_Custom> JFW_Powerup_Send_Custom_Registrant("JFW_Powerup_Send_Custom","ID:int,Message:int");
 ScriptRegistrant<JFW_Powerup_Send_Custom_Team> JFW_Powerup_Send_Custom_Team_Registrant("JFW_Powerup_Send_Custom_Team","GDIID:int,GDIMessage:int,NodID:int,NodMessage:int");
 ScriptRegistrant<JFW_Change_Character_Powerup> JFW_Change_Character_Powerup_Registrant("JFW_Change_Character_Powerup","Preset:string");
+ScriptRegistrant<JFW_Change_Character_Powerup_2> JFW_Change_Character_Powerup_2_Registrant("JFW_Change_Character_Powerup_2","GDI_Preset:string,Nod_Preset:string");
 ScriptRegistrant<JFW_Soldier_Powerup> JFW_Soldier_Powerup_Registrant("JFW_Soldier_Powerup","Message:int");
diff -uwr sourceold/scripts/jfwpow.h source/scripts/jfwpow.h
--- sourceold/scripts/jfwpow.h	2011-10-14 22:27:32.207031200 +0800
+++ source/scripts/jfwpow.h	2011-11-07 21:25:39.128906200 +0800
@@ -55,6 +55,10 @@
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
 
+class JFW_Change_Character_Powerup_2 : public ScriptImpClass {
+	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+};
+
 class JFW_Give_Money : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
diff -uwr sourceold/scripts/jfwveh.cpp source/scripts/jfwveh.cpp
--- sourceold/scripts/jfwveh.cpp	2011-10-11 23:05:04.906250000 +0800
+++ source/scripts/jfwveh.cpp	2011-12-01 12:47:58.142578100 +0800
@@ -129,7 +129,7 @@
 			{
 				firstframe = Get_Animation_Frame(obj);
 			}
-			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 		}
 	}
 	else 
@@ -140,6 +140,24 @@
 	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
 }
 
+void JFW_Vechicle_Animation::Animation_Complete ( GameObject *obj, const char *animation_name )
+{
+	if (!_stricmp(animation_name,Get_Parameter("Animation")))
+	{
+		const char *subobject = Get_Parameter("Subobject");
+		if (!_stricmp(subobject,"0"))
+		{
+			subobject = 0;
+		}
+		float firstframe = Get_Float_Parameter("FirstFrame");
+		if (firstframe == -1)
+		{
+			firstframe = Get_Animation_Frame(obj);
+		}
+		Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+	}
+}
+
 void JFW_Vechicle_Animation::Created(GameObject *obj)
 {
 	xpos = 0;
@@ -176,7 +194,7 @@
 		{
 			firstframe = Get_Animation_Frame(obj);
 		}
-		Commands->Set_Animation(object,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+		Commands->Set_Animation(object,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
 	{
@@ -224,7 +242,7 @@
 			{
 				firstframe = Get_Animation_Frame(obj);
 			}
-			Commands->Set_Animation(object,Get_Parameter("Animation1"),true,subobject,firstframe,Get_Float_Parameter("LastFrame1"),Get_Int_Parameter("Blended1"));
+			Commands->Set_Animation(object,Get_Parameter("Animation1"),false,subobject,firstframe,Get_Float_Parameter("LastFrame1"),Get_Int_Parameter("Blended1"));
 		}
 		else
 		{
@@ -245,7 +263,7 @@
 				{
 					firstframe = Get_Animation_Frame(obj);
 				}
-				Commands->Set_Animation(object,Get_Parameter("Animation2"),true,subobject,firstframe,Get_Float_Parameter("LastFrame2"),Get_Int_Parameter("Blended2"));
+				Commands->Set_Animation(object,Get_Parameter("Animation2"),false,subobject,firstframe,Get_Float_Parameter("LastFrame2"),Get_Int_Parameter("Blended2"));
 			}
 		}
 	}
@@ -415,7 +433,7 @@
 		{
 			firstframe = Get_Animation_Frame(obj);
 		}
-		Commands->Set_Animation(object,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+		Commands->Set_Animation(object,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
 
@@ -478,7 +496,7 @@
 
 void JFW_Vechicle_Animation_2::Animation_Complete(GameObject *obj,const char *animation_name)
 {
-	if (!_stricmp(animation_name,Get_Parameter("UpAnimation")))
+	if (!_stricmp(animation_name,Get_Parameter("UpAnimation")) || !_stricmp(animation_name,Get_Parameter("Animation")))
 	{
 		const char *subobject = Get_Parameter("Subobject");
 		if (!_stricmp(subobject,"0"))
@@ -488,9 +506,9 @@
 		float firstframe = Get_Float_Parameter("FirstFrame");
 		if (firstframe == -1)
 		{
-			firstframe = Get_Animation_Frame(obj);
+			firstframe = Get_Animation_Frame(Commands->Find_Object(ID));
 		}
-		Commands->Set_Animation(obj,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
 
@@ -555,7 +573,7 @@
 			{
 				firstframe = Get_Animation_Frame(obj);
 			}
-			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 		}
 	}
 	else 
@@ -566,6 +584,24 @@
 	Commands->Start_Timer(obj,this,Get_Float_Parameter("Time"),Get_Int_Parameter("TimerNum"));
 }
 
+void JFW_Vechicle_Animation_Trigger::Animation_Complete ( GameObject *obj, const char *animation_name )
+{
+	if (!_stricmp(animation_name,Get_Parameter("Animation")))
+	{
+		const char *subobject = Get_Parameter("Subobject");
+		if (!_stricmp(subobject,"0"))
+		{
+			subobject = 0;
+		}
+		float firstframe = Get_Float_Parameter("FirstFrame");
+		if (firstframe == -1)
+		{
+			firstframe = Get_Animation_Frame(obj);
+		}
+		Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+	}
+}
+
 void JFW_Vechicle_Animation_Trigger::Created(GameObject *obj)
 {
 	xpos = 0;
@@ -766,7 +802,7 @@
 			{
 				firstframe = Get_Animation_Frame(obj);
 			}
-			Commands->Set_Animation(obj,Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+			Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 		}
 	}
 	if (type == CUSTOM_EVENT_VEHICLE_EXITED)
@@ -780,6 +816,24 @@
 	}
 }
 
+void JFW_Vehicle_Effect_Animation::Animation_Complete ( GameObject *obj, const char *animation_name )
+{
+	if (!_stricmp(animation_name,Get_Parameter("Animation")))
+	{
+		const char *subobject = Get_Parameter("Subobject");
+		if (!_stricmp(subobject,"0"))
+		{
+			subobject = 0;
+		}
+		float firstframe = Get_Float_Parameter("FirstFrame");
+		if (firstframe == -1)
+		{
+			firstframe = Get_Animation_Frame(obj);
+		}
+		Commands->Set_Animation(obj,Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+	}
+}
+
 void JFW_Vehicle_Effect_Animation::Created(GameObject *obj)
 {
 	enabled = false;
diff -uwr sourceold/scripts/jfwveh.h source/scripts/jfwveh.h
--- sourceold/scripts/jfwveh.h	2011-10-14 22:27:32.110351500 +0800
+++ source/scripts/jfwveh.h	2011-12-01 12:47:58.083984300 +0800
@@ -38,6 +38,7 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
+	void Animation_Complete ( GameObject *obj, const char *animation_name );
 };
 
 class JFW_Visible_Person_In_Vechicle : public ScriptImpClass {
@@ -110,6 +111,7 @@
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
+	void Animation_Complete ( GameObject *obj, const char *animation_name );
 };
 
 class JFW_Vehicle_Block_Preset : public ScriptImpClass {
@@ -151,6 +153,7 @@
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Created(GameObject *obj);
 	public: void Register_Auto_Save_Variables();
+	void Animation_Complete ( GameObject *obj, const char *animation_name );
 };
 
 class JFW_Vehicle_Regen_2 : public ScriptImpClass {
diff -uwr sourceold/scripts/jfwws.cpp source/scripts/jfwws.cpp
--- sourceold/scripts/jfwws.cpp	2011-10-11 23:04:59.768554600 +0800
+++ source/scripts/jfwws.cpp	2011-11-07 20:33:46.811523400 +0800
@@ -687,6 +687,7 @@
 ScriptRegistrant<JFW_Permanent_No_Falling_Damage> JFW_Permanent_No_Falling_Damage_Registrant("JFW_Permanent_No_Falling_Damage","");
 ScriptRegistrant<JFW_Death_Powerup> JFW_Death_Powerup_Registrant("JFW_Death_Powerup","");
 ScriptRegistrant<JFW_GrantPowerup_Created> JFW_GrantPowerup_Created_Registrant("JFW_GrantPowerup_Created","WeaponDef:string");
+ScriptRegistrant<JFW_GrantPowerup_Created> M00_GrantPowerup_Created_Registrant("M00_GrantPowerup_Created","WeaponDef:string");
 ScriptRegistrant<JFW_CnC_Crate> JFW_CnC_Crate_Registrant("JFW_CnC_Crate","");
 ScriptRegistrant<JFW_Tiberium_Refinery> JFW_Tiberium_Refinery_Registrant("JFW_Tiberium_Refinery","MoneyAmount:int,TimerLength:int");
 ScriptRegistrant<JFW_GrantMoney_Powerup> JFW_GrantMoney_Powerup_Registrant("JFW_GrantMoney_Powerup","ScoreAmount:float,Entire_Team=0:int,Randomizer=1:int");
diff -uwr sourceold/scripts/jfwzone.cpp source/scripts/jfwzone.cpp
--- sourceold/scripts/jfwzone.cpp	2011-10-25 16:01:41.291015600 +0800
+++ source/scripts/jfwzone.cpp	2011-12-01 12:21:47.211914000 +0800
@@ -1174,7 +1174,7 @@
 
 void JFW_Zone_Animation::Animation_Complete(GameObject *obj,const char *animation_name)
 {
-	if (!_stricmp(animation_name,Get_Parameter("UpAnimation")))
+	if (!_stricmp(animation_name,Get_Parameter("UpAnimation")) || !_stricmp(animation_name,Get_Parameter("Animation")))
 	{
 		const char *subobject = Get_Parameter("Subobject");
 		if (!_stricmp(subobject,"0"))
@@ -1186,7 +1186,7 @@
 		{
 			firstframe = Get_Animation_Frame(Commands->Find_Object(ID));
 		}
-		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
 
@@ -1897,7 +1897,7 @@
 
 void JFW_Vehicle_Zone_Animation::Animation_Complete(GameObject *obj,const char *animation_name)
 {
-	if (!_stricmp(animation_name,Get_Parameter("UpAnimation")))
+	if (!_stricmp(animation_name,Get_Parameter("UpAnimation")) || !_stricmp(animation_name,Get_Parameter("Animation")))
 	{
 		const char *subobject = Get_Parameter("Subobject");
 		if (!_stricmp(subobject,"0"))
@@ -1909,7 +1909,7 @@
 		{
 			firstframe = Get_Animation_Frame(Commands->Find_Object(ID));
 		}
-		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),true,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
+		Commands->Set_Animation(Commands->Find_Object(ID),Get_Parameter("Animation"),false,subobject,firstframe,Get_Float_Parameter("LastFrame"),Get_Int_Parameter("Blended"));
 	}
 }
 
diff -uwr sourceold/scripts/scripts.vcxproj source/scripts/scripts.vcxproj
--- sourceold/scripts/scripts.vcxproj	2011-10-14 22:25:11.455078100 +0800
+++ source/scripts/scripts.vcxproj	2011-11-26 13:18:44.188476500 +0800
@@ -441,6 +441,7 @@
       <ExcludedFromBuild Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">true</ExcludedFromBuild>
       <ExcludedFromBuild Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">true</ExcludedFromBuild>
     </ClCompile>
+    <ClCompile Include="iran_scripts.cpp" />
     <ClCompile Include="jfwcine.cpp" />
     <ClCompile Include="jfwcust.cpp" />
     <ClCompile Include="jfwdef.cpp" />
@@ -665,6 +666,7 @@
     <ClInclude Include="GridCull.h" />
     <ClInclude Include="HarvesterClass.h" />
     <ClInclude Include="inttest.h" />
+    <ClInclude Include="iran_scripts.h" />
     <ClInclude Include="jfwcine.h" />
     <ClInclude Include="jfwcust.h" />
     <ClInclude Include="jfwdef.h" />
@@ -733,6 +735,7 @@
     <ClInclude Include="SceneClass.h" />
     <ClInclude Include="ScriptableGameObj.h" />
     <ClInclude Include="ScriptableGameObjDef.h" />
+    <ClInclude Include="ScriptManager.h" />
     <ClInclude Include="scripts.h" />
     <ClInclude Include="ScriptZoneGameObj.h" />
     <ClInclude Include="ScriptZoneGameObjDef.h" />
diff -uwr sourceold/scripts/scripts.vcxproj.filters source/scripts/scripts.vcxproj.filters
--- sourceold/scripts/scripts.vcxproj.filters	2011-10-14 22:25:11.498046800 +0800
+++ source/scripts/scripts.vcxproj.filters	2011-11-22 14:49:49.159179600 +0800
@@ -464,6 +464,9 @@
     <ClCompile Include="tcw_zone.cpp">
       <Filter>01. Sources\Tib. Crystal War</Filter>
     </ClCompile>
+    <ClCompile Include="iran_scripts.cpp">
+      <Filter>01. Sources</Filter>
+    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <ResourceCompile Include="scripts.rc">
@@ -1410,6 +1413,12 @@
     <ClInclude Include="tcw_defence.h">
       <Filter>02. Headers\Tib. Crystal War</Filter>
     </ClInclude>
+    <ClInclude Include="ScriptManager.h">
+      <Filter>03. New Sources</Filter>
+    </ClInclude>
+    <ClInclude Include="iran_scripts.h">
+      <Filter>02. Headers</Filter>
+    </ClInclude>
   </ItemGroup>
   <ItemGroup>
     <None Include="console.txt">
diff -uwr sourceold/scripts/vector2.h source/scripts/vector2.h
--- sourceold/scripts/vector2.h	2011-10-11 21:41:08.434570300 +0800
+++ source/scripts/vector2.h	2011-11-22 14:49:49.190429600 +0800
@@ -92,14 +92,11 @@
 	}
 	TT_INLINE void Normalize(void)
 	{
-		float len2 = Length2();
-		if (len2 != 0.0f)
-		{
+		float len2 = WWMATH_FLOAT_TINY + Length2();
 			float oolen = WWMath::Inv_Sqrt(len2);
 			X *= oolen;
 			Y *= oolen;
 		}
-	}
 	TT_INLINE float Length(void) const
 	{
 		return (float)WWMath::Sqrt(Length2());
@@ -284,13 +281,8 @@
 }
 TT_INLINE Vector2 Normalize(const Vector2 &vec)
 {
-		float len2 = vec.Length2();
-		if (len2 != 0.0f)
-		{
-			float oolen = WWMath::Inv_Sqrt(len2);
-			return vec / oolen;
-		}
-		return Vector2(0.0f,0.0f);
+		float len2 = WWMATH_FLOAT_TINY + vec.Length2();
+		return vec * WWMath::Inv_Sqrt(len2);
 }
 TT_INLINE void Swap(Vector2 & a,Vector2 & b)
 {
diff -uwr sourceold/scripts/vector4.h source/scripts/vector4.h
--- sourceold/scripts/vector4.h	2011-10-11 21:41:02.434570300 +0800
+++ source/scripts/vector4.h	2011-11-22 14:49:49.204101500 +0800
@@ -39,16 +39,13 @@
 	TT_INLINE const float& operator[](int i) const { return (&X)[i]; };
 	TT_INLINE void Normalize(void)
 	{
-		float len2 = Length2();
-		if (len2 != 0.0f)
-		{
+		float len2 = WWMATH_FLOAT_TINY + Length2();
 			float oolen = WWMath::Inv_Sqrt(len2);
 			X *= oolen;
 			Y *= oolen;
 			Z *= oolen;
 			W *= oolen;
 		}
-	}
 	TT_INLINE float Length(void) const
 	{
 		return WWMath::Sqrt(Length2());
@@ -140,13 +137,8 @@
 
 TT_INLINE Vector4 Normalize(const Vector4 & vec)
 {
-	float len2 = vec.Length2();
-	if (len2 != 0.0f)
-	{
-		float oolen = WWMath::Inv_Sqrt(len2);
-		return vec * oolen;
-	}
-	return Vector4(0.0f,0.0f,0.0f,0.0f);
+	float len2 = WWMATH_FLOAT_TINY + vec.Length2();
+	return vec * WWMath::Inv_Sqrt(len2);
 }
 
 TT_INLINE void Swap(Vector4 & a,Vector4 & b)
diff -uwr sourceold/scripts/wwmath.h source/scripts/wwmath.h
--- sourceold/scripts/wwmath.h	2011-10-11 21:40:22.365234300 +0800
+++ source/scripts/wwmath.h	2011-11-22 14:49:49.161132800 +0800
@@ -18,6 +18,7 @@
 #define WWMATH_PI				3.141592654f
 #define WWMATH_FLOAT_MAX	(FLT_MAX)
 #define WWMATH_FLOAT_MIN	(FLT_MIN)
+#define WWMATH_FLOAT_TINY	(1.0e-37f)
 #define WWMATH_SQRT2			1.414213562f
 #define WWMATH_SQRT3			1.732050808f
 #define WWMATH_OOSQRT2		0.707106781f
